import RandExp from 'randexp';
import { CustomReplacers, CustomArgs, PatternGeneratorOptions, SubstitutionMap, RandExpOptions, GenerateArgs } from './types';
export declare const patternGen: (pattern: string | RegExp, options?: PatternGeneratorOptions, args?: CustomArgs) => Promise<string>;
declare class PatternGenerator {
    simpleCounter: Generator;
    pattern: string | RegExp;
    randexpObject: RandExp;
    substitutionMap: SubstitutionMap;
    randexpPattern: string;
    getCounter: Function;
    setCounter: Function | null;
    incrementFunction: (input: string | number) => string | number;
    internalCounter: number;
    numberFormat?: Intl.NumberFormat;
    customReplacers: CustomReplacers;
    fallbackString: string;
    randexpOptions: RandExpOptions;
    constructor(pattern: string | RegExp, { getCounter, setCounter, counterInit, incrementStep, incrementFunction, customReplacers, numberFormat, fallbackString, defaultRangeAdd, defaultRangeSubtract, regexMax, }?: PatternGeneratorOptions);
    setPattern(newPattern: string | RegExp): void;
    setOptions({ getCounter, setCounter, customReplacers, numberFormat, fallbackString, defaultRangeAdd, defaultRangeSubtract, regexMax, }: PatternGeneratorOptions): void;
    gen(args?: GenerateArgs): Promise<string>;
}
export default PatternGenerator;
